Problem Link:Difficulty:Medium Prerequisites:Manacher’s Algorithm Problem:Given a string in "compressed notation"(see problem), find the number of substrings that are palindrome. Explanation:The problem was a straightforward application of Manacher’s Algorithm. This Algo was originally proposed to find the longest palindrome in a string. However, for each "center" c, it finds the length of longest palindrome "centered" at c. Therefore, we can use it to find the number of palindromes "centered" at c as well. Handling the fact that strings are given in compressed notation is relatively straightforward. Many elegant descriptions of Manacher’s Algorithm can be found on internet. In very short, Manacher’s Algorithm can be written as follows.
Assuming reader understands Manacher’s Algorithm, here is how to modify it for this problem:
There will also be minor changes like: The final Answer is
Setter's Solution:Can be found here Tester's Solution:Can be found here
This question is marked "community wiki".
asked 22 Jul '13, 00:01

I used hashing + binary search in order to find the longest palindrome centered at each of the K groups of identical characters. This gave me an O(K*log(K)) time complexity instead of O(K) (as is the case with Manacher's algorithm), but I personally prefer to use hashing whenever possible, because it's a much more general technique (applicable to a wider range of problems) and it's very easy to implement. answered 22 Jul '13, 00:18
I tried the same, but got WA for unknown reason. Going through your submission. :)
(22 Jul '13, 00:29)
In your solution, you calculate powers of 1e9+7 upto 200000 in an unsigned long long and also do the hash calculations in ULL. How is it that the 'overflowed' values don't give an error and the algorithm still works ?
(22 Jul '13, 00:40)
1
@sanchit_h because unsigned long long values automatically wraps around 2^64 on overflow.
(22 Jul '13, 00:46)
Oh. Thanks! Also, do you know why we need to a multiply the RHS value by a certain power(specifically 4*mid2) while calculating the difference in the forward and reverse hash ?
(22 Jul '13, 00:52)
Got my error. my hash function wasn't good enough. using @mugurelionut's hash func, got AC :/ @sanchit_h Haven't seen that part of his code thoroughly. But I can guess that it is due to his nature of hash function. See my code if it makes any better for you.
(22 Jul '13, 01:46)
2
@sanchit_h: My hash function considers that we have a sequence of 2N values: character1, count1, character2, count2, ..., characterN, countN. That's why I needed powers of P up to 2N basically (and not only up to N). Then, when computing the direct hash value for a substring (in my solution from imid+1 to i+mid1) we need the "prefix" hash up to i+mid1 from which we need to subtract the contribution of the "prefix" hash up to imid. But this contribution appears multiplied by P^(2 * length), where length=2*mid1 (thus, 2 * length = 4 * mid  2). The hash for the reverse string is similar.
(22 Jul '13, 01:57)
My O(Klog(K)) solution got tle. Then, i solved it with manacher. May be because of using mods :(
(22 Jul '13, 02:55)
@mugurelionut @nims11 : I have seen hashing being used for string related problems many times, but never understood how its being implemented to solve such problems. Can you provide a brief overview of the concept used in this problem and how hashing is used coupled with a binary search ? (or a link to something similar where this has been explained?)
(22 Jul '13, 12:51)
@mugurelionut : hi,could you please explain your approach in detail,how exactly you are applying hashing ?
(22 Jul '13, 14:11)
2
@sandeepandey: In this problem hashing is used to check if a substring of the given string is a palindrome. Let's say we have the substring from position i to position j. Then we compute a hash h1 for the substring from i to j and a hash h2 for the reverse substring from j to i. If h1=h2 then we can assume that the string from i to j is a palindrome (of course, we could be wrong, but it very unlikely if the hash function is good). The important part is to be able to compute such hashes in O(1) time (after some initial preprocessing).
(22 Jul '13, 16:14)
@mugurelionut: Thankyou. I understood your idea of using hashing.Thats pretty cool.but still i dont understand why you are using Binary Search here ?
(23 Jul '13, 14:04)
@sandeepandey Binary search for determining the longest length of a palindrome centered at a point.
(23 Jul '13, 14:08)
showing 5 of 12
show all

can anybody please identify why my code got SIGABRT error http://www.codechef.com/viewsolution/2396428 answered 22 Jul '13, 00:25
1
Your code would require O(10^9) memory, because it is trying to "expand" the compressed string.
(22 Jul '13, 08:57)
thanks @utkarsh_lath
(22 Jul '13, 18:35)

I wrote a very naive solution, which as I now see should most probably get TLE. But for some reason it gets WA. It works fine on any tests I can think of. Can anybody help find the reason for this WA? http://www.codechef.com/viewsolution/2397315 answered 22 Jul '13, 00:46

http://www.codechef.com/viewsolution/2396623 plz have a look.. i know its not good enough but why wrong answer? answered 22 Jul '13, 09:28
We cannot help you to debug your code, please only ask something related to the solution in the editorial!
(22 Jul '13, 10:49)
2
@tuananh93 don't be rude, of course he can ask for help First thing is I do not understand how its possible that your code works when you read c[i] twice:
but the problem is in
(22 Jul '13, 11:31)
but it will be typecasted int64 since res is int64..or not?
(22 Jul '13, 12:30)
and one c[i] is just to manange new line
(22 Jul '13, 12:31)
1
No, it's not casted to long long if result is big enought, result type is depends on arguments if those are ints, result is int.
(22 Jul '13, 13:00)

I would like to clarify about somethings. I know that we have to calculate the number of palindromic substrings centered at each letter. Here is what I did but it still gives me wrong answer. Assume A[i] is a pair or char and long long after adding (#, 0) between the letters. 1 For each A[i] init P[i] = 0. (This means am not using the symmetry property) 2 init V[i] = A[i].Y * (A[i].Y + 1) / 2; 3 while I can still expand this palindrome I wrote this code: while(A[i  P[i]  1].X == A[i + P[i] + 1].X) {
4 When manacher's algorithm is over I add all the values of V[i] to get the final result. What is wrong with this way? Why is it giving me a wrong answer. If you'd like to have a look at the full code here it is: http://www.codechef.com/viewsolution/2400280 answered 23 Jul '13, 17:31
P[i]++ should be moved to end of loop.
(23 Jul '13, 22:27)
@utkarsh Thx for that .. I saw that mistake n changed the code to http://www.codechef.com/viewsolution/2400905 but it still gives me WA. Can you plz give me a test case where it fails?
(24 Jul '13, 00:02)
Thx for the repliers ... I totally understood the question n solved it correctly :) Manacher's is in my mind now :D
(24 Jul '13, 16:34)

I tried my code with thousands of different inputs and it always gave the exact same answer as successful submissions, but I get WA. I wonder if someone can point me to any test case where my code fails. https://www.codechef.com/viewsolution/12275159 answered 14 Dec '16, 23:16

As per my understanding, we can solve this problem by writing a c program trying to find longest palindrome string centered at a character. Let the center character is 'x', then we will move in both direction of x and check if this sub string or not. IF we find that it is not a palindrome string then we can stop further scan and jump to next adjacent character in the given string. I donno how to write correct program for this .. but this algorithm looks good to me. answered 07 Apr '17, 11:58
